#include <iostream>
#include <cmath>

using namespace std;

int main()
{
    int n;
    cin>>n;
    int ov,av,bv,abv;
    cin>>ov>>av>>bv>>abv;
    int op,ap,bp,abp;
    cin>>op>>ap>>bp>>abp;
    int xo, xa,xb,xab,tempav,tempbv, tempabv;

    if(op>ov)
        cout<<"nemoguce"<<endl;
    else
    {
        cout<<"moguce"<<endl;
        if(op!=0)
        {
            ov=ov-op;
            xo=op;
            cout<<xo<<" "<<"0 "<<"0 "<<"0"<<endl;
        }
        if(ap>(ov+av))
            cout<<"nemoguce"<<endl;
        else
        {
            tempav=av;
            av=av-ap;
            if(av>=0)
            {
                xa=ap;
                cout<<"0 "<<xa<<" 0 0"<<endl;
            }
            else
            {
                ov=ov+av;
                xa=tempav;
                xo=abs(av);
                av=0;
                cout<<xo<<" "<<xa<<" 0 0"<<endl;
            }
            if(bp>(ov+bv))
            {
                cout<<"nemoguce"<<endl;
            }
            else
            {
               tempbv=bv;
               bv=bv-bp;
               if(bv>=0)
               {
                   xb=bp;
                   cout<<"0 0 "<<xb<<" 0"<<endl;
               }
               else
               {
                   ov=ov+bv;
                   xb=tempbv;
                   xo=abs(bv);
                   bv=0;
                   cout<<xo<<" 0 "<<xb<<" 0"<<endl;
               }

               if(abp>(ov+av+bv+abv))
               {
                   cout<<"nemoguce"<<endl;
               }
               else
               {
                   tempabv=abv;
                   abv=abv-abp;
                   if (abv>=0)
                   {
                       xab=abp;
                       cout<<"0 0 0 "<<xab<<endl;
                   }
                   else
                   {
                       xab=tempabv;
                       if(bv>0)
                       {
                           tempbv=bv;
                           bv=bv+abv;
                           if(bv>=0)
                           {
                               xb=abs(abv);
                               cout<<"0 0 "<<xb<<" "<<xab<<endl;
                           }
                           else
                           {
                               xb=tempbv;
                               abv=abv+tempabv;
                           }
                       }
                       else
                       {
                           xb=0;
                       }
                       if(av>0)
                       {
                           tempav=av;
                           av=av+abv;
                              if(av>=0)
                              {
                                  xa=abs(abv);
                                  cout<<"0 "<<xa<<" "<<xb<<" "<<xab<<endl;
                              }
                              else
                              {
                                  xa=tempav;
                                  abv=abv+tempabv;
                              }
                       }
                       else
                       {
                           xa=0;
                       }

                       ov=ov+abv;
                       xo=abs(abv);
                       cout<<xo<<" "<<xa<<" "<<xb<<" "<<xab<<endl;

                   }
               }
            }
        }
    }
    return 0;
}